using System;

namespace Server 
{
	public interface IArmor
	{
		double ArmorRating { get; }
	}
 
	public interface ICarvable
	{
		void Carve(Mobile from, Item item);
	}
 
	public interface IEntity : IPoint3D
	{
		Point3D Location { get; }
		Map Map { get; }
		Serial Serial { get; }
	}
 
	public interface IHued
	{
		int HuedItemID { get; }
	}

	public interface IParty
	{
		void OnManaChanged(Mobile m);
		void OnStamChanged(Mobile m);
		void OnStatsQuery(Mobile beholder, Mobile beheld);
 	}

	public interface IPoint2D
	{
		int X { get; }
		int Y { get; }
	}
 
	public interface IPoint3D : IPoint2D
	{
		int Z { get; }
	}
 
	public interface IPooledEnumerable : IEnumerable
	{
		void Free();
	}

	public interface IPooledEnumerator : IEnumerator
	{
		void Free();
		IPooledEnumerable Enumerable { get; set; }
	}

	public interface ISpell
	{
		bool OnCasterEquiping(Item item);
		void OnCasterHurt();
		void OnCasterKilled();
		bool OnCasterMoving(Direction d);
		bool OnCasterUsingObject(object o);
		bool OnCastInTown(Region r);
		void OnConnectionChanged();
		bool IsCasting { get; }
	}

	public interface IVendor
	{
		bool OnBuyItems(Mobile from, ArrayList list);
		bool OnSellItems(Mobile from, ArrayList list);
		void Restock();
		DateTime LastRestock { get; set; }
		TimeSpan RestockDelay { get; }
	}

	public interface IWeapon
	{
		void GetStatusDamage(Mobile from, ref int min, ref int max);
		TimeSpan OnSwing(Mobile attacker, Mobile defender);
		int MaxRange { get; }
 	}
 
}